//+------------------------------------------------------------------+
//|                                         Period Seperator new.mq4 |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_chart_window

//
//
//
//
//

extern int    IndicatorID    = 0;
extern string TimeFrame      = "240";
extern int    TimeShift      = 0;    // shift in hours
extern color  LineColor      = DarkOliveGreen; 
extern int    LineStyle      = STYLE_DOT;
extern int    LineWidth      = 1;
extern bool   ObjOnBckgrnd   = true;

//
//
//
//
//

int timeFrame;

//+-------------------------------------------------------------------
//|
//+-------------------------------------------------------------------
//
//
//
//
//

int init()
{
   timeFrame = stringToTimeFrame(TimeFrame);
   return(0);
}

//
//
//
//
//

int deinit()
{
   string seekName   = "PeriodSepp"+IndicatorID;
   int    seekLength = StringLen(seekName);
   
   for (int i=ObjectsTotal(); i>= 0; i--)
   {
      string name = ObjectName(i);
         if (StringSubstr(name,0,seekLength) == seekName)
                  ObjectDelete(name);
   }
   return(0);
}
 
//+-------------------------------------------------------------------
//|
//+-------------------------------------------------------------------
//
//
//
//
//
   
int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(timeFrame<=Period()) return(-1);
   if(counted_bars<0)      return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMax(MathMin(Bars-counted_bars,Bars-1),2*timeFrame/Period());

   //
   //
   //
   //
   //

   int tfs = TimeShift*3600;   
   for(i=limit; i>=0; i--)
   {
      ObjectDelete("PeriodSepp"+IndicatorID+Time[i]);

         int cbar = iBarShift(NULL,timeFrame,Time[i]+tfs);
         int pbar = iBarShift(NULL,timeFrame,Time[i+1]+tfs);
         if (cbar !=pbar)
         {
            string name = "PeriodSepp"+IndicatorID+Time[i];
            ObjectCreate(name,OBJ_VLINE,0,Time[i],High[i]);
               ObjectSet(name,OBJPROP_COLOR,LineColor);
               ObjectSet(name,OBJPROP_STYLE,LineStyle);
               ObjectSet(name,OBJPROP_WIDTH,LineWidth);
               ObjectSet(name,OBJPROP_BACK,ObjOnBckgrnd);
         }      
   }
   return(0);
}



//+------------------------------------------------------------------+
//|
//+------------------------------------------------------------------+
//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   int tf=0;
       StringToUpper(tfs); tfs = StringTrimLeft(StringTrimRight(tfs));
         if (tfs=="M1" || tfs=="1")     tf=PERIOD_M1;
         if (tfs=="M5" || tfs=="5")     tf=PERIOD_M5;
         if (tfs=="M15"|| tfs=="15")    tf=PERIOD_M15;
         if (tfs=="M30"|| tfs=="30")    tf=PERIOD_M30;
         if (tfs=="H1" || tfs=="60")    tf=PERIOD_H1;
         if (tfs=="H4" || tfs=="240")   tf=PERIOD_H4;
         if (tfs=="D1" || tfs=="1440")  tf=PERIOD_D1;
         if (tfs=="W1" || tfs=="10080") tf=PERIOD_W1;
         if (tfs=="MN" || tfs=="43200") tf=PERIOD_MN1;
         if (tf<Period()) tf=Period();
  return(tf);
}
